clc;
clear all;
close all;

N=10;

s=100;

x=[0:1/(s-1):1];

y=zeros(N,s);

for k=1:size(y,1)
    y(k,:)=(rand-0.5)+(rand-0.5).*x+(rand-0.5).*x.^2+(rand-0.5).*x.^3;
end
    
load('workspace1.mat');

figure(1);

plot(x,y','b','Linewidth',2);

set(0, 'defaultTextInterpreter', 'latex'); 

%h = legend('$C^{(1)}$','$C^{(2)}$');
%set(h,'Interpreter','latex','fontsize',25,'location','northwest');

set(gca,'FontSize',18);

xlabel('$x$','fontsize',25);
ylabel('$y$','fontsize',25);

set(get(gca,'YLabel'),'Rotation',0);

print('figure4a','-dpdf');

%save('workspace1.mat');

%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%

% proposed algorithm %

y_alg=zeros(N,s);
y_alg(:,1)=y(:,1);

temp_y_1=y_alg(:,1);
temp_y_2=y(:,2);

index=Inf;
val=Inf;

Gram=zeros(N,N);

for h=1:N
    for k1=1:N
        for k2=1:N
            Gram(k1,k2)=abs((temp_y_1(k1)-temp_y_2(k2)));
        end
    end
    val=min(min(Gram));
    index=find(Gram==val);
    r=mod(index(1),N);
    if r==0
        r=N;
    end
    c=ceil(index(1)/N);
    y_alg(r,2)=temp_y_2(c);
    temp_y_1(r)=Inf;
    temp_y_2(c)=Inf;
end

for p=3:s
    temp_y_0=y_alg(:,p-2);
    temp_y_1=y_alg(:,p-1);
    temp_y_2=y(:,p);
    
    index=Inf;
    val=Inf;
    
    Gram=zeros(N,N);
    
    for h=1:N
        for k1=1:N
            for k2=1:N
                Gram(k1,k2)=abs((temp_y_1(k1)+(temp_y_1(k1)-temp_y_0(k1))-temp_y_2(k2)));
            end
        end
        val=min(min(Gram));
        index=find(Gram==val);
        r=mod(index(1),N);
        if r==0
            r=N;
        end
        c=ceil(index(1)/N);
        y_alg(r,p)=temp_y_2(c);
        temp_y_0(r)=Inf;
        temp_y_1(r)=Inf;
        temp_y_2(c)=Inf;
    end
end

figure(2);

plot(x,y_alg','Linewidth',2);

set(0, 'defaultTextInterpreter', 'latex'); 

%h = legend('$C^{(1)}$','$C^{(2)}$');
%set(h,'Interpreter','latex','fontsize',25,'location','northwest');

set(gca,'FontSize',18);

xlabel('$x$','fontsize',25);
ylabel('$y$','fontsize',25);

set(get(gca,'YLabel'),'Rotation',0);

print('figure4b','-dpdf');

figure(3)

plot(x,y','Linewidth',2);

set(0, 'defaultTextInterpreter', 'latex'); 

%h = legend('$C^{(1)}$','$C^{(2)}$');
%set(h,'Interpreter','latex','fontsize',25,'location','northwest');

set(gca,'FontSize',18);

xlabel('$x$','fontsize',25);
ylabel('$y$','fontsize',25);

set(get(gca,'YLabel'),'Rotation',0);

%print('figure4c','-dpdf');